#include <stdio.h>
#include <stdlib.h>

#define ll long long

int main()
{
	ll int n,m,k;
	ll int tempn,tempm;
	ll int brboje = 0;
	scanf("%lli %lli %lli",&n,&m,&k);

	ll int boje;
	ll int tabela[n][m];

	//INICIJALIZACIJA//

	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			tabela[i][j] = 0;
		}
	}

	for (int i = 0; i < k; ++i)
	{
		scanf("%lli %lli", &tempn,&tempm);
		tabela[tempn-1][tempm-1] = -1; // -1 oznacava crnu boju.
	}



	for (ll int i = 0; i < n; ++i)
	{
		for (ll int j = 0; j < m; ++j)
		{

			if (tabela[i][j] == -1)
			{
				//preskace se
			}  

			//AKO NA SUSEDNIM POLJIMA NEMA BOJA ILI IMA SAMO CRNA

			else if (i == 0)  //DA LI JE PRVI RED
			{
				if(j==0)
				{
					if((tabela[i][j] == 0 || tabela[i][j] == -1) && (tabela[i][j+1] == 0 || tabela[i][j+1] == -1) && (tabela[i+1][j] == 0 || tabela[i+1][j] == -1)) //GORNJI LEVI COSAK
						{
						tabela[i][j] = brboje+1;
						++brboje;
						}
					else
						tabela[i][j] = brboje;
				}

				else if(j==m-1)
				{
					if((tabela[i][j] == 0 || tabela[i][j] == -1) && (tabela[i][j-1] == 0 || tabela[i][j-1] == -1) && (tabela[i+1][j] == 0 || tabela[i+1][j] == -1)) //GORNJI DESNI COSAK
						{
						tabela[i][j] = brboje+1;
						++brboje;
						}
					else
						tabela[i][j] = brboje;
				}

				else
				{
					if((tabela[i][j] == 0 || tabela[i][j] == -1) && (tabela[i][j-1] == 0 || tabela[i][j-1] == -1) && (tabela[i][j+1] == 0 || tabela[i][j+1] == -1) && (tabela[i+1][j] == 0 || tabela[i+1][j] == -1)) //GORNJA SREDINA
						{
						tabela[i][j] = brboje+1;
						++brboje;
						}
					else
						tabela[i][j] = brboje;
				}
			}
			else if (i == n-1) //DA LI JE POSLEDNJI RED
			{
				if(j==0)
				{
					if((tabela[i][j] == 0 || tabela[i][j] == -1) && (tabela[i][j+1] == 0 || tabela[i][j+1] == -1) && (tabela[i-1][j] == 0 || tabela[i-1][j] == -1)) //DONJI LEVI COSAK
						{
						tabela[i][j] = brboje+1;
						++brboje;
						}
					else
						tabela[i][j] = brboje;
				}

				else if(j==m-1)
				{
					if((tabela[i][j] == 0 || tabela[i][j] == -1) && (tabela[i][j-1] == 0 || tabela[i][j-1] == -1) && (tabela[i-1][j] == 0 || tabela[i-1][j] == -1)) //DONJI DESNI COSAK
						{
						tabela[i][j] = brboje+1;
						++brboje;
						}
					else
						tabela[i][j] = brboje;
				}

				else
				{
					if((tabela[i][j] == 0 || tabela[i][j] == -1) && (tabela[i][j-1] == 0 || tabela[i][j-1] == -1) && (tabela[i][j+1] == 0 || tabela[i][j+1] == -1) && (tabela[i-1][j] == 0 || tabela[i-1][j] == -1)) //DONJA SREDINA
						{
						tabela[i][j] = brboje+1;
						++brboje;
						}
					else
						tabela[i][j] = brboje;
				}
			}
			else if (j == 0) //DA LI JE PRVA KOLONA
			{
				if((tabela[i][j] == 0 || tabela[i][j] == -1) && (tabela[i][j+1] == 0 || tabela[i][j+1] == -1) && (tabela[i-1][j] == 0 || tabela[i-1][j] == -1) && (tabela[i+1][j] == 0 || tabela[i+1][j] == -1)) //LEVA SREDINA
					{
						tabela[i][j] = brboje+1;
						++brboje;
						}
				else
					tabela[i][j] = brboje;
			}
			else if (j == m-1) //DA LI JE POSLEDNJA KOLONA
			{
				if((tabela[i][j] == 0 || tabela[i][j] == -1) && (tabela[i][j-1] == 0 || tabela[i][j-1] == -1) && (tabela[i-1][j] == 0 || tabela[i-1][j] == -1) && (tabela[i+1][j] == 0 || tabela[i+1][j] == -1)) //DESNA SREDINA
					{
						tabela[i][j] = brboje+1;
						++brboje;
						}
				else
					tabela[i][j] = brboje;
			}
			else  //SREDINA
			{
				if((tabela[i][j] == 0 || tabela[i][j] == -1) && (tabela[i][j-1] == 0 || tabela[i][j-1] == -1) && (tabela[i-1][j] == 0 || tabela[i-1][j] == -1) && (tabela[i+1][j] == 0 || tabela[i+1][j] == -1) && (tabela[i][j+1] == 0 || tabela[i][j+1] == -1)) //SREDINA
						{
						tabela[i][j] = brboje+1;
						++brboje;
						}
					else
						tabela[i][j] = brboje;
			}
		}
	}

	/*
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			printf("%lli ", tabela[i][j]);
		}
		printf("\n");
	}
	*/


	printf("%lli", brboje);
	return 0;
}